	.include "a8.inc"
	.include "zp.inc"
	.include "data.inc"
;
	.export _main
	.import _graphics
_main:
START:  ; Two bytes of housekeeping that must be done...
	SEI  ; Disable interrupts
	CLD  ; Clear decimal bit
	LDX  #$FF
	TXS  ; Set stack to beginning.
	; In all truthfulness, 
	LDX  #$5D
	JSR  ClearMem ;            zero out $(A2+5E=STACK) thru $(A2+FF)
	; Re-program dlist
	JSR  MakeDlist
	CLI
	; CreateFlipTable
	JSR CreateFlipTable
	;
	LDA  #$08
	STA  PMBASE
	LDA  #$80
	STA  AUDCTL
	LDA  #$32
	STA  SDMCTL
	LDA  #$00
	STA  GRACTL
	LDA  #$04
	STA  GPRIOR
	LDA  #0
	LDY  #$80
@7:	STA  0,Y
	INY
	BNE  @7
	STA  $81
	LDA  #$10
	STA  $88         ;and $88...
	JSR  J11A3
MLOOP:  JSR  NWSCR ;            $1014
	JSR  ConSwitch
	JSR  PrepareGraphics
	JSR  StirTank
	JSR  CheckStrike
	JSR  DoMovement
	JSR  PlayerGraphics
	JSR  PrepareScores
	JSR  DrawScreen
	JMP  MLOOP
;
NWSCR:  INC  GTIMER ;  initial blanking and retrace start
	LDA  $14
@1:	CMP  $14	; Vait for Vblank
	BEQ  @1
	; STA  HMCLR ;Clear horizontal move registers.
	LDA  #$00
	STA  HMP0
	STA  HMP0+1
	STA  HMP0+2
	STA  HMP0+3
	; Colors to A8 Registers
	LDA  $d8
	STA  PCOLR0
	LDA  $d9
	STA  PCOLR1
	LDA  $da
	STA  COLOR0
	LDA  $Db
	STA  COLOR4
	LDA  #$50
	STA  HPOSP0
	LDA  #$90
	STA  HPOSP1
	RTS  
;
; Drawing the screen in the following routine.
; We start with the score, then we render the
; playfield, tanks, and missiles simultaneously.
; All in all, an average day for a VCS.
;
DrawScreen:
	LDA  #$0A
	STA  WSYNC
	; STA  HMOVE   ;Move sprites horizontally.
	LDA  #$0A
B105C:  CMP  VCOUNT
	BNE  B105C   ;Wait scanline
	STA  WSYNC
	STA  HITCLR   ;Clear collision latches
	; ToDo - STA  VBLANK  ;We even have to do our own
		     ;vertical blanking!  Oh, the
		     ;humanity!
;	LDA  #$02
;	STA  CTRLPF      ; Double, instead of reflect.
	LDX  $DC
B1070:  STA  WSYNC  ; Skip a few scanlines...
	DEX  
	BNE  B1070
	LDA  $DC
	CMP  #$0E      
	BEQ  B10CD
	; DC is set as such so that when the score is to
	; be displayed, it waits for just the right time
	; to start drawing the score, but if the score is
	; not to be displayed, as when the score flashes
	; signifying "time's almost up", it waits for just
	; the right time to start drawing the rest of the
	; screen.
;
; Start by drawing the score.
;
	LDX  #$05	; Score is five pixels high.
	LDA  #$01	; Draw double width
	STA  SIZEP0
	STA  SIZEP1
DRWSCR:  
	STA  WSYNC    ;Start with a fresh scanline.
	;Here, we begin drawing the next scanline's
	;left score, as the electron beam moves towards
	;the right score's position in this scanline.
	LDY  SCROFF+2       
	LDA  NUMBERS,Y  ;Get left digit.
	AND  #$F0       
	STA  NUMG0     
	LDY  SCROFF
	LDA  NUMBERS,Y  ;Get right digit.
	AND  #$0F
	ORA  NUMG0
	STA  NUMG0   ;Left score is ready to ship.
	LDY  SCROFF+3
	LDA  NUMBERS,Y ;Left digit...
	AND  #$F0
	STA  NUMG1
	LDY  SCROFF+1
	LDA  NUMBERS,Y ;right digit...
	AND  SHOWSCR   
	ORA  NUMG1   ;Finish calculating     (0) +3
	STA  NUMG1   ;right score.           (3) +3
	  ;We use this time to check 
	  ;whether we're at
	  ;the end of our loop.
	DEX                                ; (12)+2
	BMI  B10CD                         ; (14)+2 No Branch
	;If so, we're out of here.  Don't worry,
	;the score will be cleared immediately, so
	;nobody will know that we've gone past five
	;bytes and are displaying garbage.
	INC  SCROFF                        ; (16)+5
	INC  SCROFF+2   ; Get ready to draw the next
	INC  SCROFF+1   ; line of the byte.
	INC  SCROFF+3
	STA  WSYNC                         ; *COUNT*
	LDA  NUMG0
	STA  GRAFP0
	LDA  NUMG1
	STA  GRAFP1   ; Right score is in place.
	JMP  DRWSCR  ;Go to next scanline,
				; and that is how we do that...
;
; See what it takes just to display a pair of two-digit
; scores?  If you think that's rough, figure out how
; they displayed those six-digit scores in the early
; 1980's.  Also consider Stellar Track.... well, if
; you've seen Stellar Track, you know exactly what I'm
; talking about.  Full-fledged twelve-column text.
;
; Display loop for playfield.
;
B10CD:  LDA  #$00 ;              Inner Display Loop
	;  Normal width sprites.
	STA  SIZEP0 
	STA  SIZEP1 
	;  Clear the score.
	STA  GRAFP0 
	STA  GRAFP1 
	STA  WSYNC
	LDX  #3
@1:	LDA  HPOS,X
	SEC
	SBC  HMP0,X
	CMP  #$25
	BCS  @2
	LDA  #$D4
	BNE  @3
@2:	CMP  #$D5
	BCC  @3
	LDA  #$25
@3:	STA  HPOS,X
	DEX
	BPL  @1
	;
	LDA  HPOS
	STA  HPOSP0
	LDA  HPOS+1
	STA  HPOSP1
	LDA  RESMP0
	BNE  @4
	LDA  HPOS+2
@4:	STA  HPOSM0
	LDA  RESMP1
	BNE  @5
	LDA  HPOS+3
@5:	STA  HPOSM1
	LDA  Color0
	STA  COLPM0
	LDA  Color1
	STA  COLPM1
	LDA  #$18
	STA  ScanLine  ;We're assuming scanline 32.
;	LDA  #$05
;	STA  CTRLPF  ;Reflecting playfield.
DRWFLD:
	SEC  
	; This yields which line of player 0 to draw.
	LDA  TankY0
	SBC  ScanLine  ; A=TankY0-ScanLine
	AND  #$FE     ;Force an even number
	TAX
	; Only sixteen bytes of sprite memory, so...
	AND  #$F0
	BEQ  B10F2   ; If not valid,
	; If it's not valid, blank the tank.
	LDA  #$00 
	BEQ  B10F4 
	; Else, load the appropriate byte.
B10F2:  LDA  HIRES,X
B10F4:  STA  WSYNC ;---------------END OF ONE LINE------
	STA  GRAFP0    ; Just for player 0.
	; Keep in mind that at this point, the stack pointer
	; is set to the missile registers, and the "zero-result"
	; bit of the P register is the same at the bit ENAM0/1
	; looks at.
	LDY  #0
	LDA  MissileY1
	EOR  ScanLine
	BNE  @1
	LDY  #4
@1:	STA  TMPSTK
	LDA  MissileY0
	EOR  ScanLine  
	BNE  @2
	INY
@2:	STY  GRAFM ;       This turns the missles on/off
	;We've got the missile taken care of.
	;Now let's see which line of the playfield to draw.
	LDA  ScanLine  ;
	BPL  B110C   ;If on the bottom half of the screen,
	EOR  #$F8     ;reverse direction so we can mirror.
B110C:  CMP  #$20     ;
	BCC  B1114    ;Branch if at bottom.
	LSR   
	LSR   
	LSR          ;Divide by eight,
	TAY          ;and stow it in the Y-register.
	;By now, the electron beam is already at the next
	;scanline, so we don't have to do a STA WSYNC.
	
	; This yields which line of Tank 1 to draw.
B1114:  LDA  TankY1      ;TankY1 is other player's position.
	SEC  
	SBC  ScanLine  ;A=TankY1 - ScanLine
	INC  ScanLine  ;Increment the loop.
	NOP
	ORA  #$01     ;Add bit 0, force odd number.
	TAX  
	; There are only sixteen bytes of sprite memory, so...
	AND  #$F0 
	BEQ  B1127 
	; If tank is not ready, blank it.
	LDA  #$00  
	BEQ  B1129 
	; Else, draw tank.
B1127:  LDA  HIRES,X    ;draw the tank
B1129:  STA  GRAFP1
B113B:  INC  ScanLine   ;One more up in the loop.
	LDA  ScanLine
	EOR  #$E0      ;? When we've reached the $ECth line,
	BNE  DRWFLD    ;we've had enough.
	STA  GRAFM    ; Clear a bunch of registers.
	STA  GRAFP0
	STA  GRAFP1
	STA  GRAFP0    ;In case GRAFP0 isn't COMPLETELY zeroed.
	RTS  
;
; Executed immediately after NWSCR.
;
; This subroutine parses all the console switches.
;
ConSwitch:  
	LDA  CONSOL   ;Start/Reset button....
	LSR          ;Shove bit 0 into carry flag,
	BCS  B1170   ;and if it's pushed...
	; Start a new game.
	LDA  #$0F
	STA  SHOWSCR      ;Show right score.
	LDA  #$FF     ;Set all bits
	STA  $88      ;in $88.  
	LDA  #$80   
	STA  $DD 
	LDX  #$E6
	JSR  ClearMem ;            zero out $(A2+E6) thru $(A2+FF)
	BEQ  ResetField ;Unconditional branch
B1170:  LDY  #$02
	LDA  $DD
	AND  $88
	CMP  #$F0
	BCC  B1182
	LDA  GTIMER      ;GTIMER is the timer.
	AND  #$30
	BNE  B1182
	LDY  #$0E	; If we display no score then wait longer
B1182:  STY  $DC
	LDA  GTIMER
	AND  #$3F
	BNE  B1192
	STA  $89
	INC  $DD
	BNE  B1192
	STA  $88
B1192:  LDA  CONSOL  ; Select button.  ???
	AND  #$02
	BEQ  B119D
	LDA  #$02
	STA  $89
	BNE  CS_RTS
B119D:  BIT  $89
	BMI  CS_RTS
	INC  $80      ;Go to next game.
J11A3:  LDX  #$DF   ;Clear data from current game
B11A5:  JSR  ClearMem  ; zero out $(A2+DD/F) thru $(A2+FF)
	LDA  #$FF
	STA  $89
	LDY  $80
	LDA  VARDATA,Y  ;Get data bits for this variation.
	STA  GAMVAR
	EOR  #$FF  ;#$FF signifies end of variations
	BNE  B11BB
	LDX  #$DD
	BNE  B11A5  ; Clear all gamewise memory and start over.
B11BB:  LDA  BCDvar
	;Remember we have to increment with BCD...
	SED  
	CLC  
	ADC  #1
	STA  BCDvar
	STA  SCORE
	CLD
	BIT  GAMVAR
	BPL  ResetField  ;if this is a plane game,
	INC  GAMSHP     ;increase GAMSHP.
	BVC  ResetField  ;if this is a jet game,
	INC  GAMSHP      ;increase GAMSHP further still.
	; Branch here when game is started, too.
ResetField:
	JSR  InitField
	; Assuming plane game for now, we set the right player
	; at a slightly higher position than the left player,
	; and the position of the right player is irrelevant.
	LDA  #$3A
	STA  HPOS
	STA  HPOS+2
	LDA  #$BF
	STA  HPOS+1
	STA  HPOS+3
	;
	LDA  #$32
	STA  TankY1
	LDA  #$82
	STA  TankY0
	BIT  GAMVAR ;Check to see if it is a tank game.
	BMI  CS_RTS   
	; If it really is a tank game..
	STA  TankY1  ; Right tank has same Y value,
	; STA  RESP1   ;and tank is at opposite side.
	LDA  #$08
	STA  DIRECTN+1  ;and right player faces left.
	STA  WSYNC
CS_RTS: RTS  

;
; convert BCD scores to score pattern offset.
; This involves the horrible, horrible implications
; involved in multiplying by five.
;
; If it weren't for the geniuses at NMOS using BCD,
; this routine would be a nightmare.
;
PrepareScores:
	LDX  #$01
B11F4:  LDA  SCORE,X
	AND  #$0F
	STA  TEMP
	ASL   
	ASL   
	CLC  
	ADC  TEMP
	STA  SCROFF,X
	LDA  SCORE,X
	AND  #$F0
	LSR   
	LSR   
	STA  TEMP
	LSR   
	LSR   
	CLC  
	ADC  TEMP
	STA  SCROFF+2,X
	DEX  
	BPL  B11F4
	RTS  
;
DoMovement:  BIT  GUIDED
	BVC  B121C   ;Branch if bit 6 of 83 is clear.
	LDA  #$30
	BPL  B121E   ;JMP.
B121C:  LDA  #$20
B121E:  STA  $B1   ;Either $30 or $20 goes here...
	LDX  #$03
	JSR  J1254
	DEX        ;X, I _think_, is now 2.
	JSR  J1254
	DEX        ;And I _think_ it's now 1.
B122A:  LDA  $8D,X ;Velocity register
	AND  #$08
	LSR   
	LSR   
	STX  $D1
	CLC  
	ADC  $D1    
	TAY  ;     Y=($8D,X)&8 / 4 + X
	; $00A8,Y is either $00A8,X or $00AA,X.
	LDA  $00A8,Y ;We can't use zero-page? Waaah!
	SEC  
	BMI  B123D
	CLC
      ;^^ That's just a fancy way to
      ;   transfer bit 7 to Carry Bit.
B123D:  ROL        ;ROL, the wave of the future.
	STA  $00A8,Y
	BCC  B1250
	LDA  $AC,X
	AND  #$01
	ASL   
	ASL   
	ASL   
	ASL   
	STA  $B1  ; B1 = (AC & 1) << 4
	JSR  J1254
B1250:  DEX           ;Move to _previous_ player.
	BEQ  B122A    ;Stop if about to do player -1.  :)
	RTS  
;
; This routine will move both tanks and missiles.
; Special cases are made for missiles, which are
; otherwise treated as players 2 and 3.
;
; It doesn't change the X register, but it does
; utilize it.
;
J1254:  INC  $AC,X
	LDA  DIRECTN,X
	AND  #$0F
	CLC  
	ADC  $B1
	TAY  
	LDA  L15F7,Y  ;This has offset information.
	STA  XOFFS      ;Store the X-offset.
	BIT  $82
	BVS  B127A   ;Branch if bit 6 of 82 is set.
	LDA  DIRECTN,X
	SEC  
	SBC  #$02
	AND  #$03
	BNE  B127A
	LDA  $AC,X
	AND  #$03
	BNE  B127A   ;if AC isn't set, we're go for move.
	LDA  #$08
	STA  XOFFS
B127A:  LDA  XOFFS
	PHA
	; A8 correction
J127C:	LSR
	LSR
	LSR
	LSR
	BIT  XOFFS
	BPL  x127C
	ORA  #$F0
x127C:  STA  HMP0,X   ;Use this to move the object.
	PLA
	AND  #$0F
	SEC  
	SBC  #$08
	STA  $D4
	CLC  
	ADC  TankY0,X
	BIT  GAMVAR
	BMI  B1290    ;Branch if a plane game.
	;What follows is probably a bounds check.
	CPX  #$02
	BCS  B12A0    ;Branch if moving a missile
B1290:  CMP  #$DB
	BCS  B1298
	CMP  #$25
	BCS  B12A0
B1298:  LDA  #$D9
	BIT  $D4
	BMI  B12A0
	LDA  #$28    ;#$28 if D4 is positive, #$D9 if not
B12A0:  STA  TankY0,X  ;The tank/missile is moved here.
	CPX  #$02
	BCS  B12A8   ;Skip if moving a missile.
	; ToDo - STA  VDELP0,X ;Vertical Delay Player X...
B12A8:  RTS  
;
; This subroutine sets up the sprite data for each player by copying
; them into sixteen bytes of RAM. 
; 
; The X-register starts at 0x0E plus player number and goes down by two 
; each time through the loop, until it hits zero.  This way, after calling 
; this subroutine twice, every even-numbered byte contains the left player 
; shape, and every odd-numbered byte contains the right player shape.  Since 
; each player is updated every two scanlines, this saves us some math.
;
; Only the first 180 degrees of rotation has been drawn into ROM.  In the
; case of the other 180 degrees, this subroutine renders a flipped version
; by doing the following:
;
; 1. It sets the TIA's reflection flag for that player, taking care of 
;    the horizontal aspect rather easily.
;
; 2. It copies the bytes into memory last-to-first instead of first-to-
;    last, using the carry bit as a flag for which to do.
;
PlayerGraphics:
	LDA  #$01
	AND  GTIMER
	TAX  
	LDA  DIRECTN,X
	; ToDo - Horizontal reflection on player
	; STA  REFP0,X    ;Step 1 taken care of.
	AND  #$0F
	pha
	TAY         ;Y = DIRECTN[X] & 0x0F.
	BIT  GUIDED     
	BPL  B12BB  ;If bit 7 is set,
	STY  DIRECTN+2,X   ;then set missile bearings(?)
B12BB:  TXA        ;  X ^= 0x0E,
	EOR  #$0E   ;
	TAX        ;
	TYA  
	ASL   
	ASL   
	ASL   
	CMP  #$3F      ;And so step 2 begins...
	CLC  
	BMI  B12CB    ;Branch if <180 deg.
	SEC
	EOR  #$47      ;and it doesn't end here.
	;The EOR sets bits 0-2, and clears bit 4
	;to subtract 180 degrees from the memory
	;pointer, too.
B12CB:  TAY  
	;Put all the shapes where they ought to be.
B12CC:  LDA  (SHAPES),Y
	STA  HIRES,X
	BCC  B12D4 
	DEY  ; Decrement instead of increment
	DEY  ; plus cancel the upcoming INY.
B12D4:  INY           ;More of step 2.
	DEX  
	DEX     ;X-=2.
	BPL  B12CC ;Keep going until X runs out.
	pla
	and  #8
	beq  @2
	LDA  #7
	STA  $1f
@1:	INX
	INX
	LDA  HIRES,X
	TAY
	LDA  $600,Y
	STA  HIRES,X
	DEC  $1f
	BPL  @1
@2:	RTS  
;
;  Stir the tanks.  :-)
;
StirTank:
	LDA  $8A
	SEC  
	SBC  #$02   
	BCC  B130C ;If tank is not exploding,
		   ;parse joystick instead.
	STA  $8A
	CMP  #$02
	BCC  B130B   ;RTS if tank has
		     ;just finished exploding.
	AND  #$01     ;Stir the LOSER's tank.
	TAX  
	;One of these is the tank's bearings.
	INC  DIRECTN,X
	LDA  $D8,X
	STA  Color0,X
	LDA  $8A
	CMP  #$F7
	BCC  B12F9
	JSR  J1508
B12F9:  LDA  $8A
	BPL  B130B    ;Don't start decrementing
		      ;volume until halfway through.
	LSR   
	LSR   
	LSR   
J1300:  ; STA  AUDV1,X  ;Sound effects.  BOOOM!
	ORA  #$80 ; was LDA  #$08 (noise)
	STA  TMPSTK
	TXA
	PHA
	ASL
	TAX
	STA  AUDC1,X
	LDA  L17FE,X
	STA  AUDF1,X
	PLA
	TAX
B130B:  RTS
;
; Process joysticks.
;
B130C:  LDX  #$01
	; ToDo - Difficulty to be set by Option Key
	LDA  #0 ; CONSOL ;Console switches.
	STA  DIFSWCH    ;Store switches in D5.
	LDA  PORTA ;Joysticks.
	LSR   
	LSR   
	LSR   
	LSR        ;Keep bottom four bits (Left Player)
B1316:  BIT  $88    
	BMI  B131C ;Branch if bit 7 is set.
	LDA  #$FF  ;Freeze all joystick movement.
B131C:  EOR  #$FF  ;Reverse all bits
	AND  #$0F  ;Keep high four bits (Right Player)
	;At this point, the joystick's switches are in
	;the A-register, with a bit set wherever the
     ;joystick is pointed.
	; Bit 0 = up    Bit 1 = down
	; Bit 2 = left  Bit 3 = right
	STA  TEMP
	LDY  GAMSHP
	LDA  L170F,Y   ;Account for two-dimensional array
	CLC  
	ADC  TEMP
	TAY  
	LDA  CTRLTBL,Y
	AND  #$0F      ;Get rotation from table.
	STA  $D1
	BEQ  B1338     ;Branch if no turn.
	CMP  $91,X
	BNE  B133C     ;Some speed control I'm guessing.
B1338:  DEC  $93,X
	BNE  B1349
B133C:  STA  $91,X
	LDA  #$0F
	STA  $93,X
	; Turn the tank here. 
	LDA  $D1
	CLC  
	ADC  DIRECTN,X
	STA  DIRECTN,X
B1349:  INC  $8D,X
	BMI  B136B
	LDA  CTRLTBL,Y
	LSR   
	LSR   
	LSR   
	LSR         ;Get velocity from table.
	BIT  DIFSWCH
	BMI  B137B
B1358:  STA  $8B,X  ; Stash velocity in $8B
	ASL         ;Multiply by two
	TAY         ;Stash in Y.
	LDA  L1637,Y
	STA  $A8,X    ;This is the player's ?
	INY  
	LDA  L1637,Y
	STA  $AA,X
	LDA  #$F0
	STA  $8D,X  
B136B:  JSR  J1380
	LDA  PORTA   ;Joysticks..
	ASL  DIFSWCH   ;Use other difficulty switch.
	DEX  
	BEQ  B1316   ;
	RTS  
;
B137B:  SEC  
	SBC  GAMSHP
	BPL  B1358   ;If GAMSHP<A, then pass A-GAMSHP here.
J1380:  LDA  GAMVAR
	BMI  B138C ;If this is a tank game,
	AND  #$01   ;check also for bit 0.
	BEQ  B138C
	LDA  $DB ; Background
	STA  Color0,X ;Invisible, set colors as background
B138C:  LDA  $99,X
	BEQ  B13B7
	LDA  $D8,X
	STA  Color0,X
	LDA  $99,X
	CMP  #$07
	BCC  J13AE
	BIT  DIFSWCH
	BPL  B13A2
	CMP  #$1C
	BCC  J13AE
B13A2:  CMP  #$30
	BCC  B13C5
	CMP  #$37
	BCS  J13CB
	BIT  GUIDED
	BVC  J13CB     ;Branch if machine gun.
J13AE:  LDA  #$00
	STA  $99,X
	LDA  #$FF
B13B4:  STA  RESMP0,X  ;Reset missile to player.
	RTS  
	; I assume we get the trigger from here.
B13B7:  BIT  $88
	BPL  B13BF   ;if it's negative, go ahead.
	LDA  STRIG0,X ;Read Input (Trigger) X.
	BEQ  B13F6 ; was BPL but A8 logic is inverted
	;^^ Since the specs say there is no bit 7,
	;   I guess that means "JMP B13F6.
B13BF:  JSR  J1410
	JMP  J13AE
B13C5:  JSR  J1410
	JMP  J13DE
J13CB:  LDA  $9F,X
	BEQ  B13D9
	JSR  J1410
	LDA  #$30
	STA  $99,X
	JMP  J13DE
;
B13D9:  LDA  $99,X
	JSR  J1300
J13DE:  LDA  GTIMER
	AND  #$03
	BEQ  B13F0
	BIT  $84
	BVS  B13F2
	BIT  $82
	BVC  B13F0
	AND  #$01
	BNE  B13F2
B13F0:  DEC  $99,X
B13F2:  LDA  #$00
	BEQ  B13B4  ;Reset missiles to tanks and RTS.
	;Launch a missile.
B13F6:  LDA  #$3F
	STA  $99,X
	SEC  
	LDA  TankY0,X  ;Copy Y-position...
	SBC  #$06      ;The barrel is 6 scanlines down.
	STA  MissileY0,X
	LDA  DIRECTN,X ;Copy player bearing to missile.
	STA  DIRECTN+2,X
	LDA  HPOS,X ;Copy player xpos too
	STA  HPOS+2,X
	LDA  #$1F
	STA  $9B,X     ;9B has to do with missiles & sound.
	LDA  #$00
	STA  $9D,X     ;9D also has to do with missiles.
	JMP  J13CB
;
; This routine parses the sound effects.
;
J1410:  LDA  $9F,X
	BEQ  B1421
	TXA
	PHA
	ASL
	TAX
	;Gunshot sound.
	LDA  #$07
	; STA  AUDV1,X
	ORA  #$E0 ; was LDA  #$04 (tone)
	STA  AUDC1,X
	LDA  $9B,X  
	STA  AUDF1,X
	PLA
	TAX
	RTS  
	;Ambient sound.
B1421:  LDY  GAMSHP
	TXA
	PHA
	ASL
	TAX
	LDA  SNDV,Y
	AND  $88   ;$88 affects sound too? wow.
		   ;Perhaps speed too
;	STA  AUDV1,X ;see how it affects volume?
	ORA  SNDC,Y ; was LDA
	STA  AUDC1,X
	CLC  
	LDA  #$00
B1432:  DEY  
	BMI  B1439
	ADC  #$0C
	BPL  B1432
B1439:  ADC  $8B,X
	TAY  
	TXA  
;	ASL   
	ADC  SNDP,Y
	STA  AUDF1,X
	PLA
	TAX
	RTS  
;
; Check to see whether, during all that drawing,
; a missile hit one of the tanks.
;
	.data
M2P:	.byte 2,1
	.code
;
CheckStrike:
	LDX  #$01
J1446:  LDA  M0PL,X
	AND  M2P,X
	BEQ  B1476 ; was BPL
	BIT  $84
	BVC  B1454
	LDA  $9B,X
	CMP  #$1F
	BEQ  B1476
	;A touch, a touch!  I do confess.
B1454:  INC  DIRECTN,X  ; Turn the tanks 22.5 degrees.
	INC  DIRECTN+2,X
	;Increase player's score.
	;A simple INC SCORE,X won't do because
	;we're doing it in BCD.
	SED  
	LDA  SCORE,X
	CLC  
	ADC  #$01
	STA  SCORE,X
	CLD  
	TXA  
	CLC  
	ADC  #$FD
	STA  $8A
	;Now 8a contains loser's ID in bit 0,
	;victor's ID in bit 1, and set bits
	;2-7: the clock is ticking.
	LDA  #$FF
	STA  RESMP0   ;Reset both missiles.
	STA  RESMP1
	LDA  #$00
	STA  AUDC1,X  ;Turn off the victor's engine.
	STA  $99       ;clear 99
	STA  $9A       ;and 9A.
	RTS  

;
B1476:  BIT  GAMVAR
	BPL  B147D  ;Branch if a tank game.
	JMP  B1501
B147D:  LDA  $9F,X
	BEQ  B148B
	CMP  #$04
	INC  $9F,X
	BCC  B148B
	LDA  #$00
	STA  $9F,X
B148B:  LDA  M0PF,X   ;Missile collision with ball?
;	AND  #8
;	BNE  B1496      ;If true(?), go below...
	LDA  #$00
	STA  $9D,X       ;clear.
	JMP  J14D6
;
B1496:  BIT  $82
	BVC  B14D0  ;Branch if bit 6 is clear.
	LDA  $9D,X
	BNE  B14B7
	INC  $9F,X
	DEC  $9B,X
	LDA  DIRECTN+2,X
	STA  $B2,X
	EOR  #$FF
	STA  DIRECTN+2,X
	INC  DIRECTN+2,X
	LDA  DIRECTN+2,X
	AND  #$03
	BNE  B14B4
	INC  DIRECTN+2,X
B14B4:  JMP  J14D4
;
B14B7:  CMP  #$01
	BEQ  B14C6
	CMP  #$03
	BCC  J14D4
	BNE  J14D4
	LDA  $B2,X
	JMP  J14C8
;
; Bounce for Tank Pong... maybe.
; If I'm reading this right, it calls for a
; complete 180-degree turn.  I guess whatever
; happens after jumping to J14D4 helps a lot.
;
B14C6:  LDA  DIRECTN+2,X
J14C8:  CLC  
	ADC  #$08
	STA  DIRECTN+2,X
	JMP  J14D4
;
B14D0:  LDA  #$01
	STA  $99,X
J14D4:  INC  $9D,X
J14D6:  LDA  P0PF,X
	AND  #8
	BNE  B14DE   ;check if tank collided
		     ;with a wall.
	LDA  P0PL    ;check for a tank collision.
	AND  #2
	BEQ  B14E7
B14DE:  LDA  $8A     ;See if timer has run out.
	CMP  #$02
	BCC  B14ED
	JSR  J1508
B14E7:  LDA  #$03
	STA  $E4,X
	BNE  B1501
B14ED:  DEC  $E4,X
	BMI  B14F7
	LDA  $8B,X
	BEQ  B1501
	BNE  B14F9
B14F7:  INC  DIRECTN,X
B14F9:  LDA  DIRECTN,X
	CLC  
	ADC  #$08       ;Add 180 degrees to direction.
	JSR  J150F
B1501:  DEX  
	BMI  B1507      ;Return if X<0.
	JMP  J1446
B1507:  RTS  
;
; I bet this moves the missiles.
;
J1508:  TXA  
	EOR  #$01
	TAY        ; Y = NOT X
	LDA  DIRECTN+2,Y ;Missile's Direction
J150F:  AND  #$0F
	TAY  
	LDA  HDGTBL,Y ;Nove 
	JSR  J127C    ;Move object in that direction.
	LDA  #$00
	STA  $A8,X
	STA  $AA,X
	STA  $8D,X  ;Stop it dead in its tracks....
	LDA  $D8,X
	STA  Color0,X
	RTS  

;
; Set everything up to draw the playfield.
;
; When we find out what BB and BC are for,
; we'll keep in mind 
;
InitField:
	LDX  GAMSHP
	LDA  SPRLO,X ;Appropriate something for velocity.
	STA  SHAPES      ;Velocity could double as sprite
	LDA  SPRHI,X ;shape.
	STA  SHAPES+1
	LDA  GAMVAR
	LSR   
	LSR   
	AND  #$03  ;Determine maze type.
	TAX       ;send it to X.
	LDA  GAMVAR ;Determine game type.
	BPL  B1546  ;If a plane game,
	AND  #$08    ;test for clouds
	BEQ  B1544  ;If there are any,
	LDX  #$03    ;replace X with 3.
	;That, I don't get.  They wanted 3,
	;that fits into two bits, so why not just
	;put a 3 in there instead of going through
	;all of this?
	BPL  B1548  ;skip to next test.
B1544:  LDA  #$80    ;Otherwise,
B1546:  STA  $82     ;store $80 in 82.
B1548:  LDA  GAMVAR ;Next test..
	ASL   
	ASL         ;Do this again....
	BIT  GAMVAR 
	BMI  B1556  ;Branch if a plane game.
	STA  WSYNC
	STA  $84     ;Store GAMVAR*4 in 84.
	AND  #$80    ;IF it's a tank game.
B1556:  STA  GUIDED     ;store in 83.
	;GUIDED is ZERO if a tank game
	;it is negative if a guided missile game,
	;it is overflowed if a machine gun game.
	;(Inapplicable in tank games, hence the
	;previous branch trick)
	;
	;Store the proper offsets for each column of
	;playfield from the vectors given
	LDA  PLFPNT,X
	CLC
	ADC  #<PFWall1a
	STA  LORES
	LDA  #0
	ADC  #>PFWall1a
	STA  LORES+1
	LDA  PLFPNT+4,X
	CLC
	ADC  #<PFWall1a
	STA  LORES+2
	LDA  #0
	ADC  #>PFWall1a
	STA  LORES+3
	LDA  PLFPNT+8,X
	CLC
	ADC  #<PFWall1a
	STA  LORES+4
	LDA  #0
	ADC  #>PFWall1a
	STA  LORES+5
	;
	; A8 routine to put this data to the playfield
	;
	LDA #9
	STA bkg_x2
	LDY #0
	STY bkg_x1
	STY bkg_y
@1:	LDA (LORES),Y
	JSR to_scrn
	LDA (LORES+2),Y
	TAY
	LDA $600,Y
	ASL
	ASL
	ASL
	ASL
	JSR to_scrn
	LDA (LORES+2),Y
	TAY
	LDA $600,Y
	JSR to_scrn
	LDA (LORES+4),Y
	ASL
	ASL
	ASL
	ASL
	JSR to_scrn
	LDA (LORES+4),Y
	JSR to_scrn
	LDA bkg_x2
	CLC
	ADC #15
	STA bkg_x2
	LDA bkg_x1
	ADC #5
	STA bkg_x1
	INC bkg_y
	LDY bkg_y
	CPY #12
	BNE @1
	RTS  
;
to_scrn:
	LDX #4
	BIT  $82
	BPL  @1 ;If 82 bit set to 1, skip draw. (?)
	LDA #0
@1:	ASL
	PHP
	ROL bkg_c
	PLP
	ROL bkg_c
	DEX
	BNE @1
	LDY bkg_x2
	LDA bkg_c
	STA ($7e),Y
	TAY
	LDA $600,Y
	LDY bkg_x1
	STA ($7e),Y
	DEC bkg_x2
	INC bkg_x1
	LDY bkg_y
	RTS
;
	.bss
bkg_x1:	.res 1
bkg_x2:	.res 1
bkg_y:	.res 1
bkg_c:	.res 1
	.code
;
; I think this one determines sprite shape.
;
PrepareGraphics:
	LDA  GAMVAR
	AND  #$87
;	BMI  B157A ; Commented out for now to force single size
	;If bit 7 is set, we are playing with one or more
	;planes.  If not, well, we can only have one tank,
	;so...
	LDA  #$00
B157A:  ASL   
	TAX  
	LDA  WIDTHS,X   ;The TIA's NUSIZ registers make
	STA  SIZEP0     ;it as easy to play with two or
	LDA  WIDTHS+1,X ;three planes as it is for one
	STA  SIZEP1     ;freakin' huge bomber.
	; ToDo - allow 2 on 2 and 3 on 1
	LDA  GAMVAR
	AND  #$C0
	LSR   
	LSR   
	LSR   
	LSR         ;Our hardware is now in bits 3 and 2.
	TAY         ;Of the Y-register.
	; Render joysticks immobile if game not in play.
	LDA  $88    ;1 = Game in play
;	STA  CONSOL  ;1 = Joysticks enabled.
	EOR  #$FF
	AND  $DD
	STA  $D1
	LDX  #$FF
	LDA  #$08 ; ToDo - CONSOL do we need b/w?
	AND  #$08
	BNE  B15A7 ; B/W check
	LDY  #$10
	LDX  #$0F
B15A7:  STX  TEMP
	LDX  #$03
B15AB:  LDA  L1765,Y
	EOR  $D1
	AND  TEMP
;	STA  COLPM0,X  ;Color the real tank. Defered till later
	STA  Color0,X  ;Color the virtual tank.
	STA  $D8,X
	INY  
	DEX  
	BPL  B15AB
	RTS  
;
; Zero all memory up to $A2.  Returns with zero bit set.
;
ClearMem:
	LDA  #$00
B15BF:  INX  
	STA  $A2,X
	BNE  B15BF  ;Continue until X rolls over.
	RTS  
;
MakeDlist:
	LDA  560
	LDX  561
	STA  $80
	STX  $81
	; Set screen start pos
	CLC
	ADC  #80
	STA  $7C
	STA  $7E
	BCC  @0
	INX
@0:	STX  $7D
	STX  $7F
	LDY  #3
	LDA  #$70
	STA  ($80),Y
	INY
	LDX  #12
@1:	LDA  #64+8
	STA  ($80),Y
	INY
	LDA  $7C
	STA  ($80),Y
	INY
	LDA  $7D
	STA  ($80),Y
	INY
	LDA  #10
	CLC
	ADC  $7C
	STA  $7C
	BCC  @2
	INC  $7D
@2:	DEX
	BNE  @1
	LDX  #12
@3:	LDA  $7C
	SEC
	SBC  #10
	STA  $7C
	BCS  @4
	DEC  $7D
@4:	LDA  #64+8
	STA  ($80),Y
	INY
	LDA  $7C
	STA  ($80),Y
	INY
	LDA  $7D
	STA  ($80),Y
	INY
	DEX
	BNE  @3
	LDA  #64+1
	STA  ($80),Y
	INY
	LDA  $80
	STA  ($80),Y
	INY
	LDA  $81
	STA  ($80),Y
	RTS
;
CreateFlipTable:
	LDX     #0
@1:	TXA     
	LDY     #7
@2:	ASL     A
	ROR     $80
	DEY     
	BPL     @2
	LDA     $80
	STA     $600,X
	INX     
	BNE     @1
	RTS
